/// <reference types="react" />
import { Schema } from '../shared/schema';
import { ISchemaFormProps } from '../types';
export declare const useSchemaForm: (props: ISchemaFormProps<any, any, any, import("../types").ISchemaFormActions | import("../types").ISchemaFormAsyncActions>) => {
    form: {
        submit: (onSubmit?: (values: any) => any) => Promise<import("@formily/react").IFormSubmitResult>;
        reset: (props?: import("@formily/react").IFormResetOptions) => Promise<void | import("@formily/react").ValidateNodeResult>;
        hasChanged: (target: any, path: import("@formily/react").FormPathPattern) => boolean;
        clearErrors: (pattern?: import("@formily/react").FormPathPattern) => void;
        validate: (path?: import("@formily/react").FormPathPattern, opts?: import("@formily/react").IFormExtendedValidateFieldOptions) => Promise<import("@formily/react").ValidateNodeResult>;
        setFormState: (callback?: (state: import("@formily/react").IFormState<any>) => any, silent?: boolean) => void;
        getFormState: (callback?: (state: import("@formily/react").IFormState<any>) => any) => any;
        setFieldState: (path: import("@formily/react").FormPathPattern, callback?: (state: import("@formily/react").IFieldState<FormilyCore.FieldProps>) => void, silent?: boolean) => void;
        getFieldState: (path: import("@formily/react").FormPathPattern, callback?: (state: import("@formily/react").IFieldState<FormilyCore.FieldProps>) => any) => any;
        registerField: ({ path, name, value, initialValue, required, rules, editable, visible, display, computeState, dataType, props }: import("@formily/react").IFieldRegistryProps<FormilyCore.FieldProps>) => {
            factory: import("@formily/react").IModelSpec<Partial<import("@formily/react").IFieldState<any>>, import("@formily/react").IFieldStateProps>;
            state: import("@formily/react").IFieldState<any>;
            prevState: import("@formily/react").IFieldState<any>;
            props: import("@formily/react").IFieldStateProps;
            patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[];
            dirtyStack: import("@formily/react").StateDirtyMap<import("@formily/react").IFieldState<any>>[];
            dirtyCountStack: number[];
            batching: boolean;
            cache: Map<any, any>;
            displayName: string;
            enterCalculateDirtys(): void;
            existCalculateDirtys(): void;
            dirtys: import("@formily/react").StateDirtyMap<import("@formily/react").IFieldState<any>>;
            dirtyCount: number;
            getBaseState(): any;
            getDirtysFromPatches(patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[], refresh?: boolean): import("@formily/react").StateDirtyMap<import("@formily/react").IFieldState<any>>;
            dirtyCheck(path: import("@formily/react").FormPathPattern, nextValue: any): boolean;
            setState(recipe?: (state?: import("@formily/react").IFieldState<any>) => any, silent?: boolean): void;
            setSourceState(recipe?: (state?: import("@formily/react").IFieldState<any>) => any): import("@formily/react").IFieldState<any>;
            getState<T extends (state?: import("@formily/react").IFieldState<any>) => any>(recipe?: T): T extends (state?: import("@formily/react").IFieldState<any>) => any ? ReturnType<T> : import("@formily/react").IFieldState<any>;
            getSourceState<T_1 extends (state?: import("@formily/react").IFieldState<any>) => any>(recipe?: T_1): T_1 extends (state?: import("@formily/react").IFieldState<any>) => any ? ReturnType<T_1> : import("@formily/react").IFieldState<any>;
            batch(callback?: () => void): void;
            setCache(key: string | number | Symbol, value: any): void;
            getCache(key: string | number | Symbol): any;
            removeCache(key: string | number | Symbol): void;
            isDirty(key?: string): boolean;
            hasChanged: (pattern?: import("@formily/react").FormPathPattern) => boolean;
            subscribers: {
                [key: number]: import("@formily/shared").Subscriber<any>;
                index?: number;
            };
            subscription: import("@formily/shared").Subscription<any>;
            subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
            unsubscribe: (index: number) => void;
            notify: (payload?: any, silent?: boolean) => void;
        };
        registerVirtualField: ({ name, path, display, visible, computeState, props }: import("@formily/react").IVirtualFieldRegistryProps<FormilyCore.VirtualFieldProps>) => {
            factory: import("@formily/react").IModelSpec<Partial<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>, import("@formily/react").IVirtualFieldStateProps>;
            state: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            prevState: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            props: import("@formily/react").IVirtualFieldStateProps;
            patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[];
            dirtyStack: import("@formily/react").StateDirtyMap<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>[];
            dirtyCountStack: number[];
            batching: boolean;
            cache: Map<any, any>;
            displayName: string;
            enterCalculateDirtys(): void;
            existCalculateDirtys(): void;
            dirtys: import("@formily/react").StateDirtyMap<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
            dirtyCount: number;
            getBaseState(): any;
            getDirtysFromPatches(patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[], refresh?: boolean): import("@formily/react").StateDirtyMap<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
            dirtyCheck(path: import("@formily/react").FormPathPattern, nextValue: any): boolean;
            setState(recipe?: (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any, silent?: boolean): void;
            setSourceState(recipe?: (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any): import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            getState<T_2 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_2): T_2 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_2> : import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            getSourceState<T_3 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_3): T_3 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_3> : import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            batch(callback?: () => void): void;
            setCache(key: string | number | Symbol, value: any): void;
            getCache(key: string | number | Symbol): any;
            removeCache(key: string | number | Symbol): void;
            isDirty(key?: string): boolean;
            hasChanged: (pattern?: import("@formily/react").FormPathPattern) => boolean;
            subscribers: {
                [key: number]: import("@formily/shared").Subscriber<any>;
                index?: number;
            };
            subscription: import("@formily/shared").Subscription<any>;
            subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
            unsubscribe: (index: number) => void;
            notify: (payload?: any, silent?: boolean) => void;
        };
        createMutators: (input: any) => {
            change(...values: any[]): any;
            focus(): void;
            blur(): void;
            push(value?: any): any[];
            pop(): any[];
            insert(index: number, value: any): any;
            remove(index?: string | number): void;
            exist(index?: string | number): boolean;
            unshift(value: any): any;
            shift(): void;
            swap($from: number, $to: number): any[];
            move($from: number, $to: number): any[];
            moveUp(index: number): any[];
            moveDown(index: number): any[];
            validate(opts?: import("@formily/react").IFormExtendedValidateFieldOptions): Promise<import("@formily/react").ValidateNodeResult>;
        };
        getFormGraph: () => any;
        setFormGraph: (nodes: {
            [key: string]: any;
        }) => void;
        setFieldValue: (path: import("@formily/react").FormPathPattern, value?: any, silent?: boolean) => void;
        getFieldValue: (path?: import("@formily/react").FormPathPattern) => any;
        setFieldInitialValue: (path?: import("@formily/react").FormPathPattern, value?: any, silent?: boolean) => void;
        getFieldInitialValue: (path?: import("@formily/react").FormPathPattern) => any;
        disableUnmountClearStates: (pattern?: import("@formily/react").FormPathPattern) => void;
        enableUnmountClearStates: (pattern?: import("@formily/react").FormPathPattern) => void;
        enableUnmountRemoveNode: () => void;
        disableUnmountRemoveNode: () => void;
        isHostRendering: () => boolean;
        hostUpdate: (callback?: () => any, forceUpdate?: boolean) => any;
        subscribe: (callback?: import("@formily/react").FormHeartSubscriber) => number;
        unsubscribe: (id: number) => void;
        notify: (type: string, payload: any) => void;
    };
    formComponentProps: {};
    fields: {};
    virtualFields: {};
    formComponent: string | ((props: any) => import("react").ReactElement<any, any>) | (new (props: any) => import("react").Component<any, any, any>);
    formItemComponent: import("react").JSXElementConstructor<any>;
    schema: Schema;
    componentPropsInterceptor: (schema: import("../types").ISchema) => any;
    children: import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, any>) | (new (props: any) => import("react").Component<any, any, any>)> | import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, any>) | (new (props: any) => import("react").Component<any, any, any>)>[] | ((form: {
        submit: (onSubmit?: (values: any) => any) => Promise<import("@formily/react").IFormSubmitResult>;
        reset: (props?: import("@formily/react").IFormResetOptions) => Promise<void | import("@formily/react").ValidateNodeResult>;
        hasChanged: (target: any, path: import("@formily/react").FormPathPattern) => boolean;
        clearErrors: (pattern?: import("@formily/react").FormPathPattern) => void;
        validate: (path?: import("@formily/react").FormPathPattern, opts?: import("@formily/react").IFormExtendedValidateFieldOptions) => Promise<import("@formily/react").ValidateNodeResult>;
        setFormState: (callback?: (state: import("@formily/react").IFormState<any>) => any, silent?: boolean) => void;
        getFormState: (callback?: (state: import("@formily/react").IFormState<any>) => any) => any;
        setFieldState: (path: import("@formily/react").FormPathPattern, callback?: (state: import("@formily/react").IFieldState<FormilyCore.FieldProps>) => void, silent?: boolean) => void;
        getFieldState: (path: import("@formily/react").FormPathPattern, callback?: (state: import("@formily/react").IFieldState<FormilyCore.FieldProps>) => any) => any;
        registerField: ({ path, name, value, initialValue, required, rules, editable, visible, display, computeState, dataType, props }: import("@formily/react").IFieldRegistryProps<FormilyCore.FieldProps>) => {
            factory: import("@formily/react").IModelSpec<Partial<import("@formily/react").IFieldState<any>>, import("@formily/react").IFieldStateProps>;
            state: import("@formily/react").IFieldState<any>;
            prevState: import("@formily/react").IFieldState<any>;
            props: import("@formily/react").IFieldStateProps;
            patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[];
            dirtyStack: import("@formily/react").StateDirtyMap<import("@formily/react").IFieldState<any>>[];
            dirtyCountStack: number[];
            batching: boolean;
            cache: Map<any, any>;
            displayName: string;
            enterCalculateDirtys(): void;
            existCalculateDirtys(): void;
            dirtys: import("@formily/react").StateDirtyMap<import("@formily/react").IFieldState<any>>;
            dirtyCount: number;
            getBaseState(): any;
            getDirtysFromPatches(patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[], refresh?: boolean): import("@formily/react").StateDirtyMap<import("@formily/react").IFieldState<any>>;
            dirtyCheck(path: import("@formily/react").FormPathPattern, nextValue: any): boolean;
            setState(recipe?: (state?: import("@formily/react").IFieldState<any>) => any, silent?: boolean): void;
            setSourceState(recipe?: (state?: import("@formily/react").IFieldState<any>) => any): import("@formily/react").IFieldState<any>;
            getState<T_4 extends (state?: import("@formily/react").IFieldState<any>) => any>(recipe?: T_4): T_4 extends (state?: import("@formily/react").IFieldState<any>) => any ? ReturnType<T_4> : import("@formily/react").IFieldState<any>;
            getSourceState<T_1_1 extends (state?: import("@formily/react").IFieldState<any>) => any>(recipe?: T_1_1): T_1_1 extends (state?: import("@formily/react").IFieldState<any>) => any ? ReturnType<T_1_1> : import("@formily/react").IFieldState<any>;
            batch(callback?: () => void): void;
            setCache(key: string | number | Symbol, value: any): void;
            getCache(key: string | number | Symbol): any;
            removeCache(key: string | number | Symbol): void;
            isDirty(key?: string): boolean;
            hasChanged: (pattern?: import("@formily/react").FormPathPattern) => boolean;
            subscribers: {
                [key: number]: import("@formily/shared").Subscriber<any>;
                index?: number;
            };
            subscription: import("@formily/shared").Subscription<any>;
            subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
            unsubscribe: (index: number) => void;
            notify: (payload?: any, silent?: boolean) => void;
        };
        registerVirtualField: ({ name, path, display, visible, computeState, props }: import("@formily/react").IVirtualFieldRegistryProps<FormilyCore.VirtualFieldProps>) => {
            factory: import("@formily/react").IModelSpec<Partial<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>, import("@formily/react").IVirtualFieldStateProps>;
            state: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            prevState: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            props: import("@formily/react").IVirtualFieldStateProps;
            patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[];
            dirtyStack: import("@formily/react").StateDirtyMap<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>[];
            dirtyCountStack: number[];
            batching: boolean;
            cache: Map<any, any>;
            displayName: string;
            enterCalculateDirtys(): void;
            existCalculateDirtys(): void;
            dirtys: import("@formily/react").StateDirtyMap<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
            dirtyCount: number;
            getBaseState(): any;
            getDirtysFromPatches(patches: {
                op: "replace" | "add" | "remove";
                path: (string | number)[];
                value?: any;
            }[], refresh?: boolean): import("@formily/react").StateDirtyMap<import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>>;
            dirtyCheck(path: import("@formily/react").FormPathPattern, nextValue: any): boolean;
            setState(recipe?: (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any, silent?: boolean): void;
            setSourceState(recipe?: (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any): import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            getState<T_2_1 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_2_1): T_2_1 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_2_1> : import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            getSourceState<T_3_1 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any>(recipe?: T_3_1): T_3_1 extends (state?: import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>) => any ? ReturnType<T_3_1> : import("@formily/react").IVirtualFieldState<FormilyCore.VirtualFieldProps>;
            batch(callback?: () => void): void;
            setCache(key: string | number | Symbol, value: any): void;
            getCache(key: string | number | Symbol): any;
            removeCache(key: string | number | Symbol): void;
            isDirty(key?: string): boolean;
            hasChanged: (pattern?: import("@formily/react").FormPathPattern) => boolean;
            subscribers: {
                [key: number]: import("@formily/shared").Subscriber<any>;
                index?: number;
            };
            subscription: import("@formily/shared").Subscription<any>;
            subscribe: (callback?: import("@formily/shared").Subscriber<any>) => number;
            unsubscribe: (index: number) => void;
            notify: (payload?: any, silent?: boolean) => void;
        };
        createMutators: (input: any) => {
            change(...values: any[]): any;
            focus(): void;
            blur(): void;
            push(value?: any): any[];
            pop(): any[];
            insert(index: number, value: any): any;
            remove(index?: string | number): void;
            exist(index?: string | number): boolean;
            unshift(value: any): any;
            shift(): void;
            swap($from: number, $to: number): any[];
            move($from: number, $to: number): any[];
            moveUp(index: number): any[];
            moveDown(index: number): any[];
            validate(opts?: import("@formily/react").IFormExtendedValidateFieldOptions): Promise<import("@formily/react").ValidateNodeResult>;
        };
        getFormGraph: () => any;
        setFormGraph: (nodes: {
            [key: string]: any;
        }) => void;
        setFieldValue: (path: import("@formily/react").FormPathPattern, value?: any, silent?: boolean) => void;
        getFieldValue: (path?: import("@formily/react").FormPathPattern) => any;
        setFieldInitialValue: (path?: import("@formily/react").FormPathPattern, value?: any, silent?: boolean) => void;
        getFieldInitialValue: (path?: import("@formily/react").FormPathPattern) => any;
        disableUnmountClearStates: (pattern?: import("@formily/react").FormPathPattern) => void;
        enableUnmountClearStates: (pattern?: import("@formily/react").FormPathPattern) => void;
        enableUnmountRemoveNode: () => void;
        disableUnmountRemoveNode: () => void;
        isHostRendering: () => boolean;
        hostUpdate: (callback?: () => any, forceUpdate?: boolean) => any;
        subscribe: (callback?: import("@formily/react").FormHeartSubscriber) => number;
        unsubscribe: (id: number) => void;
        notify: (type: string, payload: any) => void;
    }) => import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, any>) | (new (props: any) => import("react").Component<any, any, any>)>);
};
