/// <reference types="react" />
import { ComponentWithStyleComponent, ISchemaFieldWrapper, ISchemaFormRegistry, ISchemaFieldComponent, ISchemaFieldComponentProps, ISchemaVirtualFieldComponentProps } from '../types';
export declare const getRegistry: () => {
    fields: {
        [key: string]: ISchemaFieldComponent;
    };
    virtualFields: {
        [key: string]: import("../types").ISchemaVirtualFieldComponent;
    };
    formItemComponent: import("react").JSXElementConstructor<any>;
    formComponent: string | ((props: any) => import("react").ReactElement<any, any>) | (new (props: any) => import("react").Component<any, any, any>);
    previewText: import("react").JSXElementConstructor<any>;
};
export declare const cleanRegistry: () => void;
export declare function registerFormComponent<Props = any>(component: React.JSXElementConstructor<Props>): void;
export declare function registerFormField(name: string, component: ComponentWithStyleComponent<ISchemaFieldComponentProps>, noWrapper?: boolean): void;
export declare function registerFormFields(object: ISchemaFormRegistry['fields']): void;
export declare function registerVirtualBox(name: string, component: ComponentWithStyleComponent<ISchemaVirtualFieldComponentProps>): void;
export declare function registerFormItemComponent(component: React.JSXElementConstructor<any>): void;
declare type FieldMiddleware = ISchemaFieldWrapper<ISchemaFieldComponentProps>;
export declare const registerFieldMiddleware: (p1?: FieldMiddleware, p2?: FieldMiddleware, p3?: FieldMiddleware, p4?: any, p5?: any) => any;
export declare function registerPreviewTextComponent<Props = any>(component: React.JSXElementConstructor<Props>): void;
export {};
